// data
 double boost_last_iteration_factor;
 bool go_for_the_last_one;
 Multicanonical_MC_eff* mmc_0_eff;
 Multicanonical_MC_eff* mmc_1_eff;
 bool control_accepted;
 bool write_to_file_voltages;
 int control_bit;
 string InDir;
 double** HistogramPtr;
 int num_histograms;
 double* sum_elem_in_histogram;
 int* num_hits_histogram;
 double* mean_pdfs;
 double* variance_pdfs;
 double* integrand_for_mean;
 double* integrand_for_power;
 ofstream* MMC_Histograms;
 Multicanonical_MC* mmc_0;
 Multicanonical_MC* mmc_1;
 Wichmann_Hill* rand_p_in; 
 Wichmann_Hill* rand_time_shift; 
 Wichmann_Hill* rand_phase_shift;
 double* values; 
 unsigned int num_n_slot_trials;
 unsigned int num_phase_shift_trials;
 double NoiseTimeShift;
 double NoisePhaseShift;
 unsigned int x_seed_used,y_seed_used,z_seed_used;
 OptSignal* SignalToPropagate;
 OptSignal* OriginalSignal;
 OptFiberLocalError* PreDCF;
 OptFiberLocalError* PostDCF;
 OptFiberLocalError* DSF35;
 OptFiberLocalError* DSF45;
 OptFiberLocalError* SMF;
 OptAmplifier* Amp;
 OptAmplifier* PAmp;
 OptDataWriter* DataWriter;
 OptFilter* ReceiverOptFilter;
 OptFilter* TransmitterOptFilter; 
 Photodetector* Detector;
 ElecFilter* ReceiverElecFilter;
 int number_of_relevant_frequencies;
 int number_of_maps;
 int number_of_channels;
 ofstream *MMC_HowClose;
 ofstream *MMC_V_try;
 LumpedLoss* Loss;
 LumpedLoss* LossPrePost;
 bool DoB2BSimulation;
 bool LoadSignalFileFlag;
 string SignalFileName;
 double* voltages;
 double* last_accepted_voltages;
 int num_bits;
 int num_zeros;
 int num_ones;
 int num_points_signal;
 double old_nonzero_bin_fraction;
 double SpecialBiasedNoise;
 double V_try_free_signal_0, V_try_free_signal_1; 
 string Job;
 int channel_to_demux_index;
 OptDemuxer* oOptDemuxer; 
 OptFilter* TunableOptFilter; 
 OptSignal* SingleChannelSignal;  
 BitString* IstanceBitString;
 bool RestartJobFlag;
 ifstream* RestartingDataFile;
 int WhichPdf_restart;
 int RestartOnesNoDataFlag;
 unsigned int TotalTimeShiftTrials_restart;
 unsigned int TotalPhaseShiftTrials_restart;
 unsigned M_restart;
 unsigned LastIteration_restart;
 double Epsilon_restart;
 unsigned N_restart;
 unsigned N_stage1_restart;
 double Nonzero_bin_fraction_restart;
 unsigned SampleTotal_restart;
 unsigned LastTau_restart;
 unsigned LastTauStage1_restart;
 double sigma_ASE_2_per_freq_compon;
 double stan_dev_freq;
 bool do_interrupted_Metropolis;   
 int NumSamplesBetweenTimeShift;
 double StdNoisePhaseShiftInRad;
 int n_slot_shift;
 int extreme_bit;
 int position_control_quantity;
 bool write_file_output_in;
 char verbose_in;
 int what_pdf;
 double min_pdf_value;
 double stop_iterations_value;
 double HowClose;  
 bool stop_when_all_bits_ok;
 bool accept_if_all_bits_in_range;
 bool keep_going;
 unsigned dim_space;
 unsigned size_z_element;
 int num_steps;
 double** P_array_ptr;
 double** g_array_ptr;
 
 
 unsigned NumIterations_0;
 double V_min_0_in;
 double V_max_0_in;
 unsigned M_0_in;
 double epsilon_0_0_in;
 double alpha_0_0_in;
 unsigned N_0_0_in;
 unsigned N_stage1_0_in;
 double N_factor_0_in;
 bool fit_P_0_in;
 bool Preset_P_0_in;
 bool Preset_g_0_in;
 double* Ptr_P_0; 
 double* Ptr_g_0;
   
 unsigned NumIterations_1;
 double V_min_1_in;
 double V_max_1_in;
 unsigned M_1_in;
 double epsilon_0_1_in;
 double alpha_0_1_in;
 unsigned N_0_1_in;
 unsigned N_stage1_1_in;
 double N_factor_1_in;
 bool fit_P_1_in;
 bool Preset_P_1_in;
 bool Preset_g_1_in;
 double* Ptr_P_1; 
 double* Ptr_g_1;
   
 unsigned int wh_x_seed,wh_y_seed,wh_z_seed;   
 unsigned int wh_x_seed_ts,wh_y_seed_ts,wh_z_seed_ts;   
 unsigned int wh_x_seed_ps,wh_y_seed_ps,wh_z_seed_ps;   
 ElecSignalStat* IstanceElecSignalStat;
 double rec_clock;
 
 // for MC simulations
 int num_samples_MC;
 double V_max;
 double V_min;
 int M;
 ofstream* MC_Voltages;
 ofstream* MC_Histogram;
 int* Histogram;
 int total_hits_in_histo;
 double volt;
 cplx* received_voltage; 
 
 
// methods
double ComputeV_try(double* z_try,bool ones_not_zeros,bool B2BSimulationFlag);
double ComputeV_try(double* z_try,bool ones_not_zeros,bool B2BSimulationFlag,double* SameKindBitVoltageArray);
void AddToHistograms(bool OnesFlag,double V_min, double V_max, int NumBins,double weight, bool accepted);
void AddToHistograms(bool OnesFlag,double V_min, double V_max, int NumBins,double weight,double previous_weight,bool accepted);
void FinalizeAndWriteFileHistograms(bool OnesFlag, double V_min_in, double V_max_in, int NumBins, int NumIteration);
void RetrieveRestartingData(string InDir);
void RetrieveRestartingData(string InDir, int num_same_kind_bits);
