// $Id:
// #####################################################################
//
//    ocsProcessControl.hh
//
//    Optical Communication Systems Simulator
//
//    Copyright:
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
// #####################################################################

#ifndef _OCS_PROCESS_CONTROL_HH_
#define _OCS_PROCESS_CONTROL_HH_


#ifndef _OCS_SYSTEM_HDRS_
#define _OCS_SYSTEM_HDRS_

#include <iostream.h>
#include <string.h>
#include <math.h> 
#include <fstream.h>
#include <complex.h>
#include <stdlib.h>
#include <stdio.h>
#include <strstream>
#include <time.h>

#include <string>
  using namespace std;

#endif /* _OCS_SYSTEM_HDRS_ */

#include "ocsReadWriteTools.hh"


//! Helps the user keep track of many processess running simultaneously

class ProcessControl
{
   public:
      void InitProcessControl( int ProcessControlMode
                         ,string ProcessControlFileName
                         ,char *ProcessName);
      ~ProcessControl();
   private:
      void OpenListProc(string ListProcFileName);
      int ProcessControlMode;
      string PathListProc;
      string ListProcMessage;
      ofstream ListProc;
      time_t InitTime;
      time_t FinalTime;
};

#endif //## _OCS_PROCESS_CONTROL_HH_
