// $Id: ocsConst.cc,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $ 

// #####################################################################
//
//    ocsConst.cc
//    
//    Initialization of the global constants   
//
//    Copyright:
//       Optical Fiber Communications Laboratory
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
// #####################################################################

#include "ocsConst.hh"

const double pi = 4*atan( (double) 1);
const double LightSpeed = 299792458; // m/s
const double hPlanck = 6.6260755e-34; // J*s
const cplx jc = cplx(0.,1.);  // =sqrt(-1)
