// $Id: ReduMain.hh,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $


// #####################################################################
//
//    main.hh
//
//    Header file for the OCS Reduced Model
//
//    Copyright: (2002)
//       Optical Fiber Communications Laboratory (OFCL)
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
// #####################################################################

#include "ocsReducedModelTools.hh"
#include "ocsReadWriteTools.hh"
#include "ocsHistogram.hh"
#include "ocsRanNumGen.hh"

// ## Reduced Polarization model
#include "ocsReduOptSignal.hh"
#include "ocsReduPolDepAttenuator.hh"
#include "ocsReduOptAmplifier.hh"
#include "ocsReduOptFiber.hh"
#include "ocsReduPolarizTransformer.hh"




























