// $Id: ocsConst.hh,v 1.1.1.1 2004/06/11 22:56:02 zweck Exp $ 

// #####################################################################
//
//    ocsConst.hh
//    
//    Header file for global constants   
//
//    Copyright:
//       Optical Fiber Communications Laboratory
//       Computer Science & Electrical Engineering Department (CSEE)
//       University of Maryland Baltimore County (UMBC)
//
// #####################################################################

#ifndef _OCS_CONST_HH
#define _OCS_CONST_HH

#include <complex.h>
typedef complex<double> cplx; 

extern const double pi,LightSpeed,hPlanck;
extern const cplx jc;

#endif /* _OCS_CONST_HH */
